local serpent=require('serpent')
local ename = {} for k,v in next,defines.events do ename[v]=k end
--
local notrace={}
local starttick = 0
local chunksrem = 0
--
function default_trace(e) print(ename[e.name],serpent.line(e)) end
--
local on = function(s,f)
    local on_s ='on_'..s
    local e = defines.events[on_s]
    if e then
        notrace[e]=true
        return script.on_event(e,f)
    else
	return script[on_s](f)
        end
    end

on('init',function()
    game.forces.player.research_all_technologies()
    game.forces.player.enable_all_recipes()
    game.forces.player.character_running_speed_modifier=1.5
    game.forces.player.character_reach_distance_bonus=32
    game.forces.player.character_build_distance_bonus=32
    game.forces.player.character_inventory_slots_bonus=40
    game.surfaces[1].always_day=true
    game.surfaces[1].request_to_generate_chunks({0,0},32) -- to avoid later benchmerk interference
    starttick = game.tick
    chunksrem = 65*65
    on('tick',function()
	if game.tick == starttick then
	    game.print('the game will chug for a few seconds, pregenerating'..
		' 65×65 chunks to avoid later benchmark interference')
	elseif game.tick == starttick+120 then
	    game.print('chugging part should be about done, background repaving of the outlands in progress...')
	    on('tick',nil)
	    end
	end)
    end)

on('research_started',function(e)
    e.research.researched=true
    end)

on('player_created',function(e)
    local p=game.players[e.player_index]
    p.cheat_mode = true
    local count = false
    for _,v in next,{1,'power-armor-mk2',1,'electric-energy-interface'
    ,'steel-axe'
    ,1,'submachine-gun','gun-turret',2000,'uranium-rounds-magazine'
    ,1000,'rail','train-stop','rail-signal','rail-chain-signal'
    ,10,'locomotive',30,'cargo-wagon'
    ,'small-electric-pole','medium-electric-pole','big-electric-pole'
    ,'arithmetic-combinator','decider-combinator','constant-combinator'
    ,'red-wire','green-wire'
    ,'construction-robot'
    ,'stack-inserter','stack-filter-inserter'
    ,'steel-chest'
    ,'logistic-chest-requester','logistic-chest-active-provider'
    ,'logistic-chest-passive-provider', 'logistic-chest-storage'
    } do
        if type(v) == 'number' then 
            count = v
        else
            if not game.item_prototypes[v] then
                p.print('no',v,'prototype?')
            else
                p.insert{name=v, count=count or game.item_prototypes[v].stack_size}
                end
            count=false
            end
        end

    local grid=p.get_inventory(defines.inventory.player_armor)[1].grid
    for _,v in next,{4,'fusion-reactor-equipment'
            ,18,'battery-mk2-equipment'
            ,4,'personal-roboport-mk2-equipment'
	    ,7,'energy-shield-mk2-equipment'} do
        if type(v) == 'number' then 
            count = v
        else
            if not game.item_prototypes[v] then
                p.print('no',v,'prototype?')
            else
                if not count then
                    count=game.item_prototypes[v].stack_size
                    end
                for _=1,count do
                    local e=grid.put{name=v}
                    if e then
                        count = count-1
                        if string.sub(v,1,7)=='battery' then
                            e.energy = e.max_energy
                            end
                        end
                    end
                if count>0 then p.insert{name=v,count=count} end
                end
            count=false
            end
        end
    end)


local pkey = function(x,y) return x*2^21+y end
local markers={} for x = -301,299,300 do for y=-301,299,300 do
    markers[pkey(x,y)] = 'hazard-concrete-left'
    markers[pkey(x+1,y)] = 'hazard-concrete-right'
    markers[pkey(x,y+1)] = 'hazard-concrete-right'
    markers[pkey(x+1,y+1)] = 'hazard-concrete-left'
    end end
--
on('chunk_generated', function(e)
    for _, entity in next,e.surface.find_entities(e.area) do
        if entity.type~='player' then entity.destroy() end
        end
    local tiles = {}
    local x,y = e.area.left_top.x, e.area.left_top.y
    for x = x-1, x + 32 do
        for y = y-1, y + 32 do
            table.insert(tiles,
                {name = markers[pkey(x,y)] or "lab-dark-2", position = {x,y}})
            end
        end
    e.surface.set_tiles(tiles)
    chunksrem = chunksrem - 1
    if chunksrem == 0 then
	game.print('background repaving complete!')
	game.forces.player.chart_all()
    elseif chunksrem < 0 then
	print(serpent.line(e.area),'generated')
	end
    end)

--[[
on('player_quickbar_inventory_changed',nil)
on('player_main_inventory_changed',nil)
on('player_crafted_item',nil)
on('robot_built_entity',nil)
on('robot_mined',nil)
on('robot_built_tile',nil)
on('robot_mined_tile',nil)
on('selected_entity_changed',nil)
on('entity_died',nil)

for k,v in next,defines.events do
    if not notrace[v] then
        script.on_event(v,default_trace)
        end
    end
--]]
-- vim: set sts=4 sw=4 tw=71 lbr fo=tcroq com=\:-- :
